ExcelTask/Controllers/ExcelImportController.cs
using ClosedXML.Excel;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ExcelTask.Models;

namespace ExcelTask.Controllers
{
    public class StudentClass
    {
        public string[] FullName { get; set; }
        public string[] Affiliate { get; set; }
        public string[] Sponsor { get; set; }
        public string[] FullNameAr { get; set; }
        public string[] Gender { get; set; }
        public string[] Nationality { get; set; }
        public string[] EmiratesId { get; set; }
        public DateTime?[] BirthDate { get; set; }
        public string[] Marital { get; set; }
        public string[] MobileNum { get; set; }
        public string[] Email { get; set; }
        public string[] LearnerStatus { get; set; }
        public string[] UserId { get; set; }
    }
    public class AdmissionClass
    {
        public string[] Admission { get; set; }
        public string[] Class { get; set; }
        public string[] Offer { get; set; }
        public string[] Eligibility { get; set; }
        public string[] PrimaryMobileNum { get; set; }
        public string[] FullName { get; set; }
        public string[] Gender { get; set; }
        public string[] Nationality { get; set; }
        public string[] EmiratesId { get; set; }
        public DateTime?[] BirthDate { get; set; }
        public DateTime?[] ApplyDate { get; set; }
        public DateTime?[] SubmitDate { get; set; }
        public DateTime?[] RegisterDate { get; set; }
        public DateTime?[] ActivationDate { get; set; }
        public string[] Marital { get; set; }
        public string[] MobileNum { get; set; }
        public string[] Email { get; set; }
    }
    public class ExcelImportController : Controller
    {
        // GET: ExcelImport
        public ActionResult Index()
        {
            return View();
        }
        [HttpPost]
        public ActionResult UploadExcel(HttpPostedFileBase file)
        {
            try
            {
                //Checking file content length and Extension must be .xlsx  
                if (file != null && file.ContentLength > 0 && Path.GetExtension(file.FileName).ToLower() == ".xlsx")
                {
                    if (!Directory.Exists(Server.MapPath("~/Content/Attachments/temp")))
                        Directory.CreateDirectory(Server.MapPath("~/Content/Attachments/temp"));
                    string path = Path.Combine(Server.MapPath("~/Content/Attachments/temp"), Path.GetFileName(file.FileName));
                    //Saving the file  
                    file.SaveAs(path);
                }
            }
            catch (Exception ee)
            {
                TempData["Error"] = "File format is not acceptable!";
            }
            return Json("File Upload Successfully");
        }
        public ActionResult GetExcelData(string path)
        {
            DataTable dt = new DataTable();
            try
            {
                path = Path.Combine(Server.MapPath("~/Content/Attachments/temp"), path);
                dt = ReadExcelFile(path);
                if (dt.Columns.Count == 13)
                    return View("Learner", dt);
                else
                    return View("Addmission", dt);

            }
            catch (Exception ee)
            {
            }
            return View("Index", dt);

        }
        [HttpPost]
        public DataTable ReadExcelFile(string path)
        {
            DataTable dt = new DataTable();
            //Started reading the Excel file.  
            using (XLWorkbook workbook = new XLWorkbook(path))
            {
                IXLWorksheet worksheet = workbook.Worksheet(1);
                bool FirstRow = true;
                //Range for reading the cells based on the last cell used.  
                string readRange = "1:1";
                foreach (IXLRow row in worksheet.RowsUsed())
                {
                    //If Reading the First Row (used) then add them as column name  
                    if (FirstRow)
                    {
                        //Checking the Last cellused for column generation in datatable  
                        readRange = string.Format("{0}:{1}", 1, row.LastCellUsed().Address.ColumnNumber);
                        foreach (IXLCell cell in row.Cells(readRange))
                        {
                            dt.Columns.Add(cell.Value.ToString());
                        }
                        FirstRow = false;
                    }
                    else
                    {
                        //Adding a Row in datatable  
                        dt.Rows.Add();
                        int cellIndex = 0;
                        //Updating the values of datatable  
                        foreach (IXLCell cell in row.Cells(readRange))
                        {
                            dt.Rows[dt.Rows.Count - 1][cellIndex] = cell.Value.ToString();
                            cellIndex++;
                        }
                    }
                }
                //If no data in Excel file  
                if (FirstRow)
                    ViewBag.Message = "Empty Excel File!";
            }
            // If file found, delete it 
            if (System.IO.File.Exists(path))   
                System.IO.File.Delete(path);
            return dt;
        }
        [HttpPost]
        public ActionResult UploadStudentData(StudentClass param)
        {
            Models.ExcelTask db = new Models.ExcelTask();
            try
            {
                string missingMsg = "These user Email or Emirate Id is missing ";
                for (int i = 0; i < param.FullName.Length; i++)
                {
                    sp_StudentInfo_Post_Result model = db.sp_StudentInfo_Post(param.FullName[i], param.Affiliate[i], param.Sponsor[i], param.FullNameAr[i],
                        param.Gender[i], param.Nationality[i], param.EmiratesId[i], param.BirthDate[i], param.Marital[i], param.MobileNum[i], param.Email[i], param.LearnerStatus[i],
                        param.UserId[i]).FirstOrDefault();
                    if(model.Message == "Emirates ID and Email cannot be null")
                    {
                        missingMsg = missingMsg + param.FullName[i] + ", ";
                        TempData["Message"] = missingMsg;
                    }
                }
                if (TempData["Message"] == null)
                    TempData["Success"] = "Data Uploaded Successfully!";
            }
            catch (Exception ee)
            {
                TempData["Error"] = "Execution Time Error: " + ee.Message;
            }
            return RedirectToAction("Index");
        }
        [HttpPost]
        public ActionResult UploadAdmissionData(AdmissionClass param)
        {
            Models.ExcelTask db = new Models.ExcelTask();
            try
            {
                string missingMsg = "These user Email or Emirate Id is missing ";
                for (int i = 0; i < param.Admission.Length; i++)
                {
                    sp_AdmissionInfo_Post_Result model = db.sp_AdmissionInfo_Post(param.FullName[i], param.Gender[i], param.Nationality[i], param.EmiratesId[i],
                        param.BirthDate[i], param.Marital[i], param.MobileNum[i], param.Email[i], param.Admission[i], param.Class[i],
                        param.ApplyDate[i], param.SubmitDate[i], param.Offer[i], param.Eligibility[i], param.RegisterDate[i], param.ActivationDate[i],
                        param.PrimaryMobileNum[i]).FirstOrDefault();
                    if (model.Message == "Emirates ID and Email cannot be null")
                    {
                        missingMsg = missingMsg + param.FullName[i] + ", ";
                        TempData["Message"] = missingMsg;
                    }
                }
                if (TempData["Message"] == null)
                    TempData["Success"] = "Data Uploaded Successfully!";
            }
            catch (Exception ee)
            {
                TempData["Error"] = "Execution Time Error: " + ee.InnerException;
            }
            return RedirectToAction("Index");
        }
    }
}

ExcelTask/Views/Shared/_Footer.cshtml
<!-- begin:: Footer -->
<div class="kt-footer  kt-grid__item kt-grid kt-grid--desktop kt-grid--ver-desktop" id="kt_footer">
    <div class="kt-container  kt-container--fluid ">
        <div class="kt-footer__copyright">
            2018 - @DateTime.Now.Year &copy; Developed by&nbsp;&copy;&nbsp; <a href="#" class="m-link"><i class="fa fa-laptop-code"></i> Muhammad Atif Sohail</a>
        </div>
        <div class="kt-footer__menu">
            <a href="#" target="_blank" class="kt-footer__menu-link kt-link">About</a>
            <a href="#" target="_blank" class="kt-footer__menu-link kt-link">Team</a>
            <a href="#" class="kt-footer__menu-link kt-link">Contact</a>
        </div>
    </div>
</div>


<!-- end:: Footer -->

ExcelTask/Views/Shared/_Header.cshtml
@using (Html.BeginForm("LogOff", "Account", FormMethod.Post, new { id = "logoutForm", @class = "navbar-right" }))
{
    @Html.AntiForgeryToken()
}


<div id="kt_quick_user" class="offcanvas offcanvas-right p-10">
    <!--begin::Header-->
    <div class="offcanvas-header d-flex align-items-center justify-content-between pb-5">
        <h3 class="font-weight-bold m-0">
            User Profile
            @*<small class="text-muted font-size-sm ml-2">12 messages</small>*@
        </h3>
        <a href="#" class="btn btn-xs btn-icon btn-light btn-hover-primary" id="kt_quick_user_close">
            <i class="ki ki-close icon-xs text-muted"></i>
        </a>
    </div>
    <!--end::Header-->
    <!--begin::Content-->
    <div class="offcanvas-content pr-5 mr-n5">
        <!--begin::Header-->
        <div class="d-flex align-items-center mt-5">
            <div class="symbol symbol-100 mr-5">
                <div class="symbol-label" style="background-image:url('')"></div>
                <i class="symbol-badge bg-success"></i>
            </div>
            <div class="d-flex flex-column">
                <a href="#" class="font-weight-bold  text-dark-75 text-hover-primary"></a>
                <div class="text-muted mt-1"></div>
                <div class="navi mt-2">
                    <a href="#" class="navi-item">
                        <span class="navi-link p-0 pb-2">
                            <span class="navi-icon mr-1">
                                <span class="svg-icon svg-icon-lg svg-icon-primary">
                                    <!--begin::Svg Icon | path:~/Content/media/svg/icons/Communication/Mail-notification.svg-->
                                    <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                            <rect x="0" y="0" width="24" height="24" />
                                            <path d="M21,12.0829584 C20.6747915,12.0283988 20.3407122,12 20,12 C16.6862915,12 14,14.6862915 14,18 C14,18.3407122 14.0283988,18.6747915 14.0829584,19 L5,19 C3.8954305,19 3,18.1045695 3,17 L3,8 C3,6.8954305 3.8954305,6 5,6 L19,6 C20.1045695,6 21,6.8954305 21,8 L21,12.0829584 Z M18.1444251,7.83964668 L12,11.1481833 L5.85557487,7.83964668 C5.4908718,7.6432681 5.03602525,7.77972206 4.83964668,8.14442513 C4.6432681,8.5091282 4.77972206,8.96397475 5.14442513,9.16035332 L11.6444251,12.6603533 C11.8664074,12.7798822 12.1335926,12.7798822 12.3555749,12.6603533 L18.8555749,9.16035332 C19.2202779,8.96397475 19.3567319,8.5091282 19.1603533,8.14442513 C18.9639747,7.77972206 18.5091282,7.6432681 18.1444251,7.83964668 Z" fill="#000000" />
                                            <circle fill="#000000" opacity="0.3" cx="19.5" cy="17.5" r="2.5" />
                                        </g>
                                    </svg>
                                    <!--end::Svg Icon-->
                                </span>
                            </span>
                        </span>
                    </a>
                </div>
                <a href="javascript:document.getElementById('logoutForm').submit();" class="btn btn-sm btn-info">Signout</a>
            </div>
        </div>
        <!--end::Header-->
        <!--begin::Separator-->
        <div class="separator separator-dashed mt-8 mb-5"></div>
        <!--end::Separator-->
        <!--begin::Nav-->
        <div class="navi navi-spacer-x-0 p-0">
            <!--begin::Item-->
            <a href="https://rainmaker.pk/Users/Profile/" class="navi-item">
                <div class="navi-link">
                    <div class="symbol symbol-40 bg-light mr-3">
                        <div class="symbol-label">
                            <span class="svg-icon svg-icon-md svg-icon-success">
                                <!--begin::Svg Icon | path:~/Content/media/svg/icons/General/Notification2.svg-->
                                <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                    <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                        <rect x="0" y="0" width="24" height="24" />
                                        <path d="M13.2070325,4 C13.0721672,4.47683179 13,4.97998812 13,5.5 C13,8.53756612 15.4624339,11 18.5,11 C19.0200119,11 19.5231682,10.9278328 20,10.7929675 L20,17 C20,18.6568542 18.6568542,20 17,20 L7,20 C5.34314575,20 4,18.6568542 4,17 L4,7 C4,5.34314575 5.34314575,4 7,4 L13.2070325,4 Z" fill="#000000" />
                                        <circle fill="#000000" opacity="0.3" cx="18.5" cy="5.5" r="2.5" />
                                    </g>
                                </svg>
                                <!--end::Svg Icon-->
                            </span>
                        </div>
                    </div>
                    <div class="navi-text">
                        <div class="font-weight-bold">My Profile</div>
                        <div class="text-muted">
                            Account settings and more
                            <span class="label label-light-danger label-inline font-weight-bold">update</span>
                        </div>
                    </div>
                </div>
            </a>
            <!--end:Item-->
            <!--begin::Item-->
            <a href="https://rainmaker.pk/Users/Messages/" class="navi-item">
                <div class="navi-link">
                    <div class="symbol symbol-40 bg-light mr-3">
                        <div class="symbol-label">
                            <span class="svg-icon svg-icon-md svg-icon-warning">
                                <!--begin::Svg Icon | path:~/Content/media/svg/icons/Shopping/Chart-bar1.svg-->
                                <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                    <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                        <rect x="0" y="0" width="24" height="24" />
                                        <rect fill="#000000" opacity="0.3" x="12" y="4" width="3" height="13" rx="1.5" />
                                        <rect fill="#000000" opacity="0.3" x="7" y="9" width="3" height="8" rx="1.5" />
                                        <path d="M5,19 L20,19 C20.5522847,19 21,19.4477153 21,20 C21,20.5522847 20.5522847,21 20,21 L4,21 C3.44771525,21 3,20.5522847 3,20 L3,4 C3,3.44771525 3.44771525,3 4,3 C4.55228475,3 5,3.44771525 5,4 L5,19 Z" fill="#000000" fill-rule="nonzero" />
                                        <rect fill="#000000" opacity="0.3" x="17" y="11" width="3" height="6" rx="1.5" />
                                    </g>
                                </svg>
                                <!--end::Svg Icon-->
                            </span>
                        </div>
                    </div>
                    <div class="navi-text">
                        <div class="font-weight-bold">My Messages</div>
                        <div class="text-muted">Inbox and tasks</div>
                    </div>
                </div>
            </a>
            <!--end:Item-->
            <!--begin::Item-->
            <a href="https://rainmaker.pk/Calendar/Index/" class="navi-item">
                <div class="navi-link">
                    <div class="symbol symbol-40 bg-light mr-3">
                        <div class="symbol-label">
                            <span class="svg-icon svg-icon-md svg-icon-danger">
                                <!--begin::Svg Icon | path:~/Content/media/svg/icons/Files/Selected-file.svg-->
                                <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                    <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                        <polygon points="0 0 24 0 24 24 0 24" />
                                        <path d="M4.85714286,1 L11.7364114,1 C12.0910962,1 12.4343066,1.12568431 12.7051108,1.35473959 L17.4686994,5.3839416 C17.8056532,5.66894833 18,6.08787823 18,6.52920201 L18,19.0833333 C18,20.8738751 17.9795521,21 16.1428571,21 L4.85714286,21 C3.02044787,21 3,20.8738751 3,19.0833333 L3,2.91666667 C3,1.12612489 3.02044787,1 4.85714286,1 Z M8,12 C7.44771525,12 7,12.4477153 7,13 C7,13.5522847 7.44771525,14 8,14 L15,14 C15.5522847,14 16,13.5522847 16,13 C16,12.4477153 15.5522847,12 15,12 L8,12 Z M8,16 C7.44771525,16 7,16.4477153 7,17 C7,17.5522847 7.44771525,18 8,18 L11,18 C11.5522847,18 12,17.5522847 12,17 C12,16.4477153 11.5522847,16 11,16 L8,16 Z" fill="#000000" fill-rule="nonzero" opacity="0.3" />
                                        <path d="M6.85714286,3 L14.7364114,3 C15.0910962,3 15.4343066,3.12568431 15.7051108,3.35473959 L20.4686994,7.3839416 C20.8056532,7.66894833 21,8.08787823 21,8.52920201 L21,21.0833333 C21,22.8738751 20.9795521,23 19.1428571,23 L6.85714286,23 C5.02044787,23 5,22.8738751 5,21.0833333 L5,4.91666667 C5,3.12612489 5.02044787,3 6.85714286,3 Z M8,12 C7.44771525,12 7,12.4477153 7,13 C7,13.5522847 7.44771525,14 8,14 L15,14 C15.5522847,14 16,13.5522847 16,13 C16,12.4477153 15.5522847,12 15,12 L8,12 Z M8,16 C7.44771525,16 7,16.4477153 7,17 C7,17.5522847 7.44771525,18 8,18 L11,18 C11.5522847,18 12,17.5522847 12,17 C12,16.4477153 11.5522847,16 11,16 L8,16 Z" fill="#000000" fill-rule="nonzero" />
                                    </g>
                                </svg>
                                <!--end::Svg Icon-->
                            </span>
                        </div>
                    </div>
                    <div class="navi-text">
                        <div class="font-weight-bold">Calendar</div>
                        <div class="text-muted">Create & Share your organizational calendar</div>
                    </div>
                </div>
            </a>
            <!--end:Item-->
            <!--begin::Item-->
            @*<a href="@Url.Action("Index","Task")" class="navi-item">
                    <div class="navi-link">
                        <div class="symbol symbol-40 bg-light mr-3">
                            <div class="symbol-label">
                                <span class="svg-icon svg-icon-md svg-icon-primary">
                                    <!--begin::Svg Icon | path:~/Content/media/svg/icons/Communication/Mail-opened.svg-->
                                    <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                            <rect x="0" y="0" width="24" height="24" />
                                            <path d="M6,2 L18,2 C18.5522847,2 19,2.44771525 19,3 L19,12 C19,12.5522847 18.5522847,13 18,13 L6,13 C5.44771525,13 5,12.5522847 5,12 L5,3 C5,2.44771525 5.44771525,2 6,2 Z M7.5,5 C7.22385763,5 7,5.22385763 7,5.5 C7,5.77614237 7.22385763,6 7.5,6 L13.5,6 C13.7761424,6 14,5.77614237 14,5.5 C14,5.22385763 13.7761424,5 13.5,5 L7.5,5 Z M7.5,7 C7.22385763,7 7,7.22385763 7,7.5 C7,7.77614237 7.22385763,8 7.5,8 L10.5,8 C10.7761424,8 11,7.77614237 11,7.5 C11,7.22385763 10.7761424,7 10.5,7 L7.5,7 Z" fill="#000000" opacity="0.3" />
                                            <path d="M3.79274528,6.57253826 L12,12.5 L20.2072547,6.57253826 C20.4311176,6.4108595 20.7436609,6.46126971 20.9053396,6.68513259 C20.9668779,6.77033951 21,6.87277228 21,6.97787787 L21,17 C21,18.1045695 20.1045695,19 19,19 L5,19 C3.8954305,19 3,18.1045695 3,17 L3,6.97787787 C3,6.70173549 3.22385763,6.47787787 3.5,6.47787787 C3.60510559,6.47787787 3.70753836,6.51099993 3.79274528,6.57253826 Z" fill="#000000" />
                                        </g>
                                    </svg>
                                    <!--end::Svg Icon-->
                                </span>
                            </div>
                        </div>
                        <div class="navi-text">
                            <div class="font-weight-bold">My Tasks</div>
                            <div class="text-muted">latest tasks and projects</div>
                        </div>
                    </div>
                </a>*@
            <!--end:Item-->
        </div>
        <!--end::Nav-->
        <!--begin::Separator-->
        <div class="separator separator-dashed my-7"></div>
        <!--end::Separator-->
        <!--begin::Notifications-->
        <!--end::Notifications-->
    </div>
    <!--end::Content-->
</div>

ExcelTask/Views/Shared/_navbar.cshtml
<ul class="menu-nav ">

    <li class="menu-section">
        <h4 class="menu-text">Uploading - Module</h4>
        <i class="menu-icon ki ki-bold-more-hor icon-md"></i>
    </li>

    <li class="menu-item menu-item-submenu" aria-haspopup="true" data-menu-toggle="hover">
        <a href="javascript:;" class="menu-link menu-toggle">
            <span class="svg-icon menu-icon">
                <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                    <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                        <rect id="bound" x="0" y="0" width="24" height="24" />
                        <rect id="Rectangle-151" fill="#000000" opacity="0.3" x="4" y="4" width="8" height="16" />
                        <path d="M6,18 L9,18 C9.66666667,18.1143819 10,18.4477153 10,19 C10,19.5522847 9.66666667,19.8856181 9,20 L4,20 L4,15 C4,14.3333333 4.33333333,14 5,14 C5.66666667,14 6,14.3333333 6,15 L6,18 Z M18,18 L18,15 C18.1143819,14.3333333 18.4477153,14 19,14 C19.5522847,14 19.8856181,14.3333333 20,15 L20,20 L15,20 C14.3333333,20 14,19.6666667 14,19 C14,18.3333333 14.3333333,18 15,18 L18,18 Z M18,6 L15,6 C14.3333333,5.88561808 14,5.55228475 14,5 C14,4.44771525 14.3333333,4.11438192 15,4 L20,4 L20,9 C20,9.66666667 19.6666667,10 19,10 C18.3333333,10 18,9.66666667 18,9 L18,6 Z M6,6 L6,9 C5.88561808,9.66666667 5.55228475,10 5,10 C4.44771525,10 4.11438192,9.66666667 4,9 L4,4 L9,4 C9.66666667,4 10,4.33333333 10,5 C10,5.66666667 9.66666667,6 9,6 L6,6 Z" id="Combined-Shape" fill="#000000" fill-rule="nonzero" />
                    </g>
                </svg>
            </span><span class="menu-text">Excel Upload</span><i class="menu-arrow"></i>
        </a>
        <div class="menu-submenu ">
            <i class="menu-arrow"></i>
            <ul class="menu-subnav">
                <li class="menu-item menu-item-submenu" aria-haspopup="true" data-menu-toggle="hover">
                    <a href="@Url.Action("Index", "ExcelImport")" class="menu-link"><i class="menu-link-bullet menu-link-bullet--dot"><span></span></i><span class="menu-text">Excel Uploader</span></a>
                </li>
                
            </ul>
        </div>
    </li>


</ul>